//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include <stdio.h>
#include <math.h>
#include <string.h>
#include <gsl/gsl_sort.h>
#include <gsl/gsl_wavelet2d.h>
#define alloc(type, p_name, num) type p_name = (type*)malloc(num*sizeof(type))

int n=256, FLAG=0;

/*
#define PIX_SORT(a,b) { if ((a)>(b)) PIX_SWAP((a),(b)); }
#define PIX_SWAP(a,b) { double temp=(a);(a)=(b);(b)=temp; }

double opt_med9(double * p)
{
    PIX_SORT(p[1], p[2]) ; PIX_SORT(p[4], p[5]) ; PIX_SORT(p[7], p[8]) ;
    PIX_SORT(p[0], p[1]) ; PIX_SORT(p[3], p[4]) ; PIX_SORT(p[6], p[7]) ;
    PIX_SORT(p[1], p[2]) ; PIX_SORT(p[4], p[5]) ; PIX_SORT(p[7], p[8]) ;
    PIX_SORT(p[0], p[3]) ; PIX_SORT(p[5], p[8]) ; PIX_SORT(p[4], p[7]) ;
    PIX_SORT(p[3], p[6]) ; PIX_SORT(p[1], p[4]) ; PIX_SORT(p[2], p[5]) ;
    PIX_SORT(p[4], p[7]) ; PIX_SORT(p[4], p[2]) ; PIX_SORT(p[6], p[4]) ;
    PIX_SORT(p[4], p[2]) ; return(p[4]) ;
}
#undef PIX_SORT
#undef PIX_SWAP

int cntr=-1; //    33,   
double array[9]; //    

void selarr(double *img, int x0, int y0, int width){
	int x, y,tx,ty;
	double *tmp;	
	if(cntr==-1){ //   
		tmp = array;
		tx=x0+2; ty=y0+2; 
		for (y=y0-1; y<ty;y++)
			for(x=x0-1;x<tx;x++) //   
				*tmp++ = img[y*width + x];
		cntr=0; //      
	}
	else{
		tmp = &array[cntr*3]; //    
		ty = y0+2; tx=x0+1;
		for(y=y0-1; y<ty; y++) //    
			*tmp++ = img[y*width + tx];
		if(++cntr > 2) cntr = 0;
	}
}

void medfilt(double *img, double *filtered, int w, int h){
	int x, y, xx, yy;
	xx = w - 1; yy = h - 1;
	for(y=1; y<yy; y++){ //   img_filtered
		cntr = -1;
		for(x=1; x<xx; x++){
			selarr(img,x,y,w);
			filtered[y*w+x] = 
				opt_med9(array);
		}
	}
	y=h-1;
	for(x=0; x<w; x++){
		filtered[x] = filtered[w+x]; //  
		filtered[y*w+x] = filtered[(y-1)*w+x]; //  
	}
	x=w-1;
	for(y=0; y<h; y++){
		filtered[y*w] = filtered[y*w+1]; //  
		filtered[y*w+x] = filtered[y*w+x-1]; //  
	}
}
*/

void findcenter(double *image_w){
	int x,y, I=0;
	double xcn=0.,ycn=0.;
	double *w = image_w;
	FILE *fcn = fopen("wcenter", "w");
	for(y=0; y<n; y++){
		for(x=0; x<n; x++){
			if(*w++ < 0.01) continue;
			xcn += x;
			ycn += y;
			I++;
		}
	}
	xcn /= I;
	ycn /= I;
	fprintf(fcn, "xc=%g, yc=%g\n", xcn, ycn);
	if(FLAG) printf("xc=%g, yc=%g\n", xcn, ycn);
	fclose(fcn);
}

int main(int argc, char **argv){
	int i, x, y, nc=1000, tmp;
	double xc, yc, *ptr;
	char datain[33] = "2D";
	alloc(double, *data, n*n);
	alloc(double, *medf, n*n);
	alloc(double, *abscoeff, n*n);
	alloc(size_t, *p, n*n);
	FILE *f, *fw, *fltrd;
	gsl_wavelet *w;
	gsl_wavelet_workspace *work;
	if(argc > 1) nc=atoi(argv[1]);
	if(argc > 2){
		FLAG = 1;
		strncpy(datain, argv[2], 32);
	}
	w = gsl_wavelet_alloc(gsl_wavelet_daubechies, 4);
//	w = gsl_wavelet_alloc(gsl_wavelet_haar, 2); 
	work = gsl_wavelet_workspace_alloc(n);
	fw = fopen("wave2D", "w");
	f = fopen(datain, "r");
	//fltrd = fopen("wave2Df", "w");
	ptr = data;
	for(y=0; y<n; y++)
		for(x=0; x<n; x++){
			fscanf(f, "%lf", ptr++);// &data[x + y*n]);
		}
	fclose(f);
	/*medfilt(data, medf, n, n);
	ptr = medf;
	for(y=0; y<n; y++){
		for(x=0; x<n; x++){
			fprintf(fltrd,"%g ", *ptr);
			*ptr++ = 1;
		}
		fprintf(fltrd, "\n");
		}
	fclose(fltrd);*/
//for(tmp = 0; tmp< 1000; tmp++){
	gsl_wavelet2d_transform_forward(w, data, 0, n, n, work);
	i = n*n;
	for(x=0; x<i; x++)
		abscoeff[x] = fabs(data[x]);
	gsl_sort_index(p, abscoeff, 1, n*n);
	y = i - nc;
	for(x=0; x<y; x++)
		data[p[x]] = 0;
	gsl_wavelet2d_transform_inverse(w, data, 0, n, n, work);
	ptr = data;
	for(y=0; y<n; y++){
		for(x=0; x<n; x++){
			if(!FLAG) printf("%g ", *ptr);//data[x + y*n]);
			fprintf(fw,"%g ", *ptr++); //data[x + y*n]);
		}
		if(!FLAG) printf("\n");
		fprintf(fw, "\n");
	}
	findcenter(data);
//}
	gsl_wavelet_free(w),
	gsl_wavelet_workspace_free(work);
	free(data);
	free(abscoeff);
	free(p);
	fclose(fw);
	return 0;
}

