#ifndef FIBER_GUIDE_CGI_H
#define FIBER_GUIDE_CGI_H 
#include <asm/types.h>
#include <assert.h>
#include <ctype.h>
#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <fcntl.h> 
#include <fftw3.h>
#include <getopt.h>
#include <gsl/gsl_sort.h>
#include <gsl/gsl_wavelet2d.h>
#include <linux/videodev2.h>
#include <malloc.h>
#include <math.h>
#include <pthread.h>
#include <pwd.h>
#include <signal.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <sys/ipc.h>
#include <sys/mman.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/types.h>
#include <termio.h>
#include <termios.h>
#include <time.h>
#include <unistd.h>

#include "iftest.h"
#include "wavecorr.h"
#include "img_functions.h"
#include "jpeg_streaming.h"
#include "killbrothers.h"
#include "motor-func.h"
#include "quick_median.h"
#include "v4l2control.h"
#include "CGI_auth.h"

#define FIFO_OUT "/var/www/tmp/fifo-out"
#define SHMEM_FILE "fiber_guide.prms"
extern int get_auth_level(); //  CGI_auth.c

double dsleep(double dt);
double dtime();
double ltime();

extern FILE *outfile;

extern double xtarg, ytarg, dt_live;
extern pthread_mutex_t mutex;
void rm_queues();

extern double* filterbuf; // ,      ( F_control)
// filterbuf   v4l2control.c

#ifdef FIBER_GUIDE_CGI_C
FILE* outfile;
double brightness, contrast;
double xtarg=384.; /* screen target position of object (pix)*/
double ytarg=256.;
unsigned char nMask = 10; // -    
double dt_live = 0.3; // ~2.5Hz livecam 
double time0=0.; //   
double frametime=0.; //  ""  

int fw, fh, width, height;
unsigned char *image; //    
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;	//    
						// 	      
/*
pthread_mutex_lock(&mutex) -       
pthread_mutex_unlock(&mutex) - 
pthread_mutex_trylock(&mutex) -    */

void sendJavaScript(char *msg, bool sflag);
#endif // FIBER_GUIDE_CGI_C
#endif // FIBER_GUIDE_CGI_H
