#ifndef IMG_FUNCTIONS_H
#define IMG_FUNCTIONS_H
#include "fiber_guide_cgi.h"

#ifdef IMG_FUNCTIONS_C
#define Extern
#else
#define Extern extern
#endif //IMG_FUNCTIONS_C

#define MIN_AVR_LEVEL	3.0	//    ,  -
#define MIN_STD_LEVEL	2.0	//    -//-

#define XSteps (pars->SX)
#define YSteps (pars->SY)
#define xcent (pars->xcentre)
#define ycent (pars->ycentre)
#define RealFrameRate (pars->framerate)
#define FrameS (pars->framesize)
#define Xtarg  (pars->xtarg)	//   
#define Ytarg  (pars->ytarg)	// (   )
#define Xprev	(pars->xprev)	//  
#define Yprev	(pars->yprev)	// 
#define Nadd   (pars->nadd)
#define FrameRate  (pars->frmrate)
#define GrabChan   (pars->nchan)
#define Grab_Width  (pars->imgwidth)
#define Grab_Height (pars->imgheight)
#define ComPort    (pars->comport)
#define Contrast	(pars->contrast)
#define Brightness	(pars->brightness)
#define HistFilt	(pars->histfilt)
#define Guiding		(pars->guiding)
#define MOVETOCENTER	(pars->moveto)
#define Reset		(pars->reset)
#define Init		(pars->init)
#define Lamp		(pars->lamp)
#define Shutter		(pars->shutter)
#define Ch_obj		(pars->ch_obj)
#define CMass		(pars->centermass)
#define dX			(pars->corrDX)
#define dY			(pars->corrDY)
#define dCam		(pars->dPhiCam)
#define CamPos		(pars->CamPhi)
#define newCamPos	(pars->CamPhi_new)
#define dGr			(pars->dPhiGr)
#define GrPos		(pars->GrPhi)
#define newGrPos	(pars->GrPhi_new)
#define dPh			(pars->dPhocus)
#define Ph			(pars->Phocus)
#define newPh		(pars->Phocus_new)
#define F_TYPE		(pars->type)
#define W_filter	(pars->Wavelet)
#define F_control	(pars->filtcontrol)
#define ShowHist	(pars->show_histogram)
#define XHist		(pars->xhist)
#define histVmin	(pars->histmin)
#define histVmax	(pars->histmax)
#define Shutter_lock (pars->exposure)
#define ExpTime		(pars->expotime)

#define JPEG_QUALITY      95
#define LIVE_JPEG_QUALITY 80
#define GRAB_SOURCE       1		/* start with chan1 ("Composite0") */
#define GRAB_NADD         1

void copy_image(unsigned char *image, int width, int x0, int y0, int size);
void add_image(unsigned char *image, int width, int x0, int y0, int size);
//int  check_tv_signal();
void grab_adjust_brightness(double adjval);
void grab_adjust_contrast(double adjval);

#ifndef FIBER_GUIDE_CGI_C
extern
#endif
struct Params {
	double framerate;	//	  -    
	int framesize;		//	  {32, [64], 128, 256}
	int xtarg;			//	  ,    
	int ytarg;			//				
	int SX;				//	 ()  - 
	int SY;				//				,   
	double xprev;		//	    X (dx_0)
	double yprev;		//				-//-   Y (dy_0)
	double xcentre;		//	    X (dx)
	double ycentre;		//				-//-   Y (dy)
	int nadd;			//	- ,     ( )
	double frmrate;		//	-        
	int nchan;			//	,   "" 
	int imgwidth;		//	  ( )
	int imgheight;		//	 -//-
	double brightness;	//	  (1..100, [50.])
	double contrast;	//	  (0..100, [50.])
	bool histfilt;		//	   (  ) {1, [0]}
	bool guiding;		//	/ .  {1, [0]}
	bool moveto;		//	   XY   {1, [0]}
	bool reset;			//	     (1 - , [0])
	bool init;			//	    (1, [0])
	unsigned char comport;//  ([0], )
	char lamp;			//	/  ([0] - .  ,
						//		1 - , 2 - , 4 -  , 8 -  )
	bool shutter;		//	  ([0] - , 1 - )
	bool ch_obj;		//	   ([0], 1)
	bool centermass;	//	 ""     ([0], 1)
	int corrDX;			//	    (. -  )
	int corrDY;
	char dPhiCam;		//	   
	int CamPhi;			//	    (  )
	int CamPhi_new;		//	,   
	char dPhiGr;		//	   
	int GrPhi;			//	    (  )
	int GrPhi_new;		//	,   
	char dPhocus;		//	 
	int Phocus;			//	  (  )
	int Phocus_new;		//	,   	
	filter_type type;	//	  {[No], Wavelet, Median}
	W_filt Wavelet;		//	 - (treshold {,[32]},  {,[4]})
	bool filtcontrol;	//	     ([0], 1)
	bool show_histogram;//	      ([0], 1)
	int xhist;			//	   
	int histmin;		//	 
	int histmax;		//		    
	bool exposure;		//	  -     ([0], 1)
	int expotime;		//	,       
} *pars;

#ifdef IMG_FUNCTIONS_C
int stat_image(unsigned char *image, int x0, int y0, int frame_size);

double img[MAX_WIDTH*MAX_HEIGHT];

fftw_plan fftimg, fftmask, ifft;
fftw_complex *mask, *Fimg, *Fmask, *Ffilter;
void Build_filter(int size);
void Zero_Matrix(fftw_complex *Matrix, int size);
void Realloc4Matrix(int sizex, int sizey);
extern double dtime();

double LG[6][6];
#endif //IMG_FUNCTIONS_C
#endif //IMG_FUNCTIONS_H

