//      This program is free software; you can redistribute it and/or modify
//      it under the terms of the GNU General Public License as published by
//      the Free Software Foundation; either version 2 of the License, or
//      (at your option) any later version.
//      
//      This program is distributed in the hope that it will be useful,
//      but WITHOUT ANY WARRANTY; without even the implied warranty of
//      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//      GNU General Public License for more details.
//      
//      You should have received a copy of the GNU General Public License
//      along with this program; if not, write to the Free Software
//      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
//      MA 02110-1301, USA.

#include "killbrothers.h"
#define PROC_BASE "/proc"

char *pidfilename = "fg_pid";

void readname(char *name, pid_t pid){ //     /proc/...
	char *pp = name, byte, path[256];
	int cntr = 0, file;
	sprintf (path, PROC_BASE "/%d/cmdline", pid);
	file = open(path, O_RDONLY);
	do{	//    
		read(file, &byte, 1);
		if (byte != '/') *pp++ = byte;
		else pp = name;
	}
	while(byte != EOF && byte != 0 && cntr++ < 255);
	close(file);
}

void killbrothers(int flag){
	DIR *dir;
	FILE* pidfile;
	struct dirent *de;
	struct stat s_buf;
	pid_t pid, self, run = 0;
	char name[256], myname[256];
	if (!(dir = opendir (PROC_BASE))){ //   /proc
		perror (PROC_BASE);
		exit (1);
	}
	self = getpid(); //  
	if(stat(pidfilename, &s_buf) == 0){ //    pid'
		pidfile = fopen(pidfilename, "r");
		fscanf(pidfile, "%d", &run); //  pid ()  
		fclose(pidfile);
	}
	readname(myname, self); //   
	while ((de = readdir (dir)) != NULL){ //      
	// ,      ,    self
		if (!(pid = (pid_t) atoi (de->d_name)) || pid == self)
			continue;
		readname(name, pid); //   
		if(strncmp(name, myname, 255) == 0){ //     myname
			WARN("\nFound running process (pid=%d), ", pid);
			if(flag == 1){
				WARN("killing\n");
				kill(pid, SIGQUIT); // ,  flag == 1
			}
			else{
				kill(pid, SIGUSR1); //      
				if(pid == run){
					WARN("exiting.\n");
					printf("init=false\n");
					exit(0);
				}
			}
		}
	}
	closedir(dir);
	unlink(pidfilename); //   pidfilename
	if(flag == 1){
		WARN("QUIT\n");
		printf("killall=0\n");
		sleep(3);
		rm_queues();
		exit(0); 
	}
	if(flag == 2){
		WARN("my PID: %d\n", self);
		pidfile = fopen(pidfilename, "w");
		fprintf(pidfile, "%d\n", self); //   pidfilename  pid
		fclose(pidfile);
	}
}

