/*
 * This code by Nicolas Devillard - 1998. Public domain.
 *  quick_select   
 *     
 */
#include "quick_median.h"

#define ALGO_OPTIM //   
//   : #define ALGO_QUICK ()

//#ifdef ALGO_QUICK
#define ELEM_SWAP(a,b) { register elem_type t=(a);(a)=(b);(b)=t; }
elem_type quick_select(elem_type mas[], int n)
{
     int low, high, i;
     int median;
     int middle, ll, hh;
     elem_type ret, *in_ptr, *out_ptr;
     elem_type* arr = (elem_type*)calloc(n, sizeof(elem_type));
     in_ptr = mas; out_ptr = arr;
     for(i = 0; i < n; i++)
     	*(out_ptr++) = *(in_ptr++);
     low = 0 ; high = n-1 ; median = (low + high) / 2;
     for (;;) {
         if (high <= low) /* One element only */
			break;
         if (high == low + 1) { /* Two elements only */
             if (arr[low] > arr[high])
                 ELEM_SWAP(arr[low], arr[high]) ;
             break;
         }
     /* Find median of low, middle and high items; swap into position low */
     middle = (low + high) / 2;
     if (arr[middle] > arr[high])    ELEM_SWAP(arr[middle], arr[high]) ;
     if (arr[low] > arr[high])       ELEM_SWAP(arr[low], arr[high]) ;
     if (arr[middle] > arr[low])     ELEM_SWAP(arr[middle], arr[low]) ;
     /* Swap low item (now in position middle) into position (low+1) */
     ELEM_SWAP(arr[middle], arr[low+1]) ;
     /* Nibble from each end towards middle, swapping items when stuck */
     ll = low + 1;
     hh = high;
     for (;;) {
         do ll++; while (arr[low] > arr[ll]) ;
         do hh--; while (arr[hh] > arr[low]) ;
         if (hh < ll)
         break;
         ELEM_SWAP(arr[ll], arr[hh]) ;
     }
     /* Swap middle item (in position low) back into correct position */
     ELEM_SWAP(arr[low], arr[hh]) ;
     /* Re-set active partition */
     if (hh <= median)
         low = ll;
        if (hh >= median)
        high = hh - 1;
    }
	ret = arr[median];
	free(arr);
	return ret;
}
#undef ELEM_SWAP
//#endif // ALGO_QUICK

#ifdef ALGO_OPTIM
#define PIX_SORT(a,b) { if ((a)>(b)) PIX_SWAP((a),(b)); }
#define PIX_SWAP(a,b) { elem_type temp=(a);(a)=(b);(b)=temp; }

elem_type opt_med9(elem_type * p)
{
    PIX_SORT(p[1], p[2]) ; PIX_SORT(p[4], p[5]) ; PIX_SORT(p[7], p[8]) ;
    PIX_SORT(p[0], p[1]) ; PIX_SORT(p[3], p[4]) ; PIX_SORT(p[6], p[7]) ;
    PIX_SORT(p[1], p[2]) ; PIX_SORT(p[4], p[5]) ; PIX_SORT(p[7], p[8]) ;
    PIX_SORT(p[0], p[3]) ; PIX_SORT(p[5], p[8]) ; PIX_SORT(p[4], p[7]) ;
    PIX_SORT(p[3], p[6]) ; PIX_SORT(p[1], p[4]) ; PIX_SORT(p[2], p[5]) ;
    PIX_SORT(p[4], p[7]) ; PIX_SORT(p[4], p[2]) ; PIX_SORT(p[6], p[4]) ;
    PIX_SORT(p[4], p[2]) ; return(p[4]) ;
}
#undef PIX_SORT
#undef PIX_SWAP
#endif // ALGO_OPTIM

int cntr=-1; //    33,   
elem_type array[9]; //    

/*
	     33   array
	img - , x0,y0 -   , width -  
*/
void selarr(elem_type *img, int x0, int y0, int width){
	int x, y,tx,ty;
	elem_type *tmp;	
	if(cntr==-1){ //   
		tmp = array;
		tx=x0+2; ty=y0+2; 
		for (y=y0-1; y<ty;y++)
			for(x=x0-1;x<tx;x++) //   
				*tmp++ = img[y*width + x];
		cntr=0; //      
	}
	else{
		tmp = &array[cntr*3]; //    
		ty = y0+2; tx=x0+1;
		for(y=y0-1; y<ty; y++) //    
			*tmp++ = img[y*width + tx];
		if(++cntr > 2) cntr = 0;
	}
}

/*
		     33
	!   (1 )  ,    !
	img - , img_ -     ( )
	w, h -    
*/
void medfilt(elem_type *img, int size){
	int x, y, xx, yy;
	elem_type img_filtered[size][size];
	elem_type *img_pntr = img;
#ifdef __MORE_TEST__
	fprintf(stderr, "\n__medfilt on img(%dx%d): ", size, size);
#endif
	xx = size - 1;
	for(y=1; y<xx; y++){ //   img_filtered
		cntr = -1;
		for(x=1; x<xx; x++){
			selarr(img,x,y,size);
			img_filtered[y][x] = 
				#ifdef ALGO_QUICK
				quick_select(array, 9);
				#endif
				#ifdef ALGO_OPTIM
				opt_med9(array);
				#endif
		}
	}
	//   
	// (   )
	y=size-1;
	for(x=0; x<size; x++){
		img_filtered[0][x] = img_filtered[1][x]; //  
		img_filtered[y][x] = img_filtered[y-1][x]; //  
	}
	x=size-1;
	for(y=0; y<size; y++){
		img_filtered[y][0] = img_filtered[y][1]; //  
		img_filtered[y][x] = img_filtered[y][x-1]; //  
	}
	xx = size;
#ifdef __MORE_TEST__
	fprintf(stderr, "preparing.. ");
#endif
	for(y=0; y<size; y++)
		for(x=0; x<size; x++)
			*img_pntr++ = img_filtered[y][x];
#ifdef __MORE_TEST__
	fprintf(stderr, "done!__\n");
#endif
}


