#ifndef __WAVECORR_H__
#define __WAVECORR_H__
#include "fiber_guide_cgi.h"
#define MAX_WIDTH         800
#define MAX_HEIGHT        600

//  
typedef enum{
	No	= 0,
	Wavelet	= 1,
	Median	= 2
} filter_type;
//  Wavelet-
typedef struct{
	int treshold; // -  
	int order; //   (  - 4)
} W_filt;

void findcenter(filter_type type, double *xc, double *yc, int size);
//void makeRefImage(filter_type type, unsigned char* image, int width, int x0, int y0, int size);
void makeRefImage(filter_type type, int size);
void Realloc_memory(int frame_size);

#ifdef __WAVECORR_C__
double img0[MAX_WIDTH*MAX_HEIGHT];
extern double img[];
double *abscoeff, *CCF = NULL;
size_t *p;

gsl_wavelet *w;
gsl_wavelet_workspace *work;

fftw_complex *fft0, *fft1, *fft2;
fftw_plan im0, im1, rev;

void wavefilt(double *data, int size);
void filter_image(filter_type type, double* image, int size);
#endif //__WAVECORR_C__

#endif /* __WAVECORR_H__ */
